#include <windows.h>
#include "../vc++/pdfformfunc.h"
#include <io.h>
#include <stdio.h>
#include <string>
using namespace std;

void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

void TestFormFiller1()
{
	char szBarcodeTemp[MAX_PATH];
	GetModulePath(szBarcodeTemp, "Barcode-temp2.pdf");
	char szBarcodeNew[MAX_PATH];
	GetModulePath(szBarcodeNew, "_Barcode-temp2-out.pdf");
	
	string strFormValues;
	strFormValues += "BarCode1[0]=>Code128=>1234567890";
	strFormValues += "\n";
	strFormValues += "BarCode2[0]=>Code39=>1234567890";
	strFormValues += "\n";
	strFormValues += "BarCode3[0]=>Codabar=>A1234567890A";
	strFormValues += "\n";
	strFormValues += "BarCode4[0]=>Datamatrix=>01034009377771791712073110BXBWWW22";
	strFormValues += "\n";
	strFormValues += "BarCode5[0]=>EAN=>01234567890100";
	strFormValues += "\n";
	strFormValues += "BarCode6[0]=>Inter25=>123456789";
	strFormValues += "\n";
	strFormValues += "BarCode7[0]=>PDF417=>1234567890";
	strFormValues += "\n";
	strFormValues += "BarCode8[0]=>Postnet=>1234567890";
	strFormValues += "\n";
	strFormValues += "BarCode10[0]=>GS1DataMatrix=>(1)12345678901234(17)BX123456CrLfHumanReadablePosition";
	int bRet = PDFForm_InsertBarcodeIntoPDF2(szBarcodeTemp, szBarcodeNew, strFormValues.c_str());
	
	printf("Return value is: %d\n", bRet);
}

void TestFormFiller2()
{
	char szBarcodeTemp[MAX_PATH];
	GetModulePath(szBarcodeTemp, "Barcode-temp.pdf");
	char szBarcodeNew[MAX_PATH];
	GetModulePath(szBarcodeNew, "_Barcode-temp-out.pdf");

	string strFormValues;
	strFormValues += "BarCode1[0]=>Code128=>1234567890";
	strFormValues += "\n";
	strFormValues += "BarCode2[0]=>Code39=>1234567890";
	strFormValues += "\n";
	strFormValues += "BarCode3[0]=>Codabar=>A1234567890A";
	strFormValues += "\n";
	strFormValues += "BarCode4[0]=>Datamatrix=>01034009377771791712073110BXBWWW22";
	strFormValues += "\n";
	strFormValues += "BarCode5[0]=>EAN=>01234567890100";
	strFormValues += "\n";
	strFormValues += "BarCode6[0]=>Inter25=>123456789";
	strFormValues += "\n";
	strFormValues += "BarCode7[0]=>PDF417=>1234567890";
	strFormValues += "\n";
	strFormValues += "BarCode8[0]=>Postnet=>1234567890";
	strFormValues += "\n";
	strFormValues += "DataMatrixBarCode1=>GS1DataMatrix=>(1)12345678901234(17)BX123456CrLfHumanReadablePosition";
	int bRet = PDFForm_InsertBarcodeIntoPDF2(szBarcodeTemp, szBarcodeNew, strFormValues.c_str());

	printf("Return value is: %d\n", bRet);
}

void TestFormFiller3()
{
	char szFDFFile[MAX_PATH];
	GetModulePath(szFDFFile, "80082088_GS1DM.fdf");
	char szPDFFile[MAX_PATH];
	GetModulePath(szPDFFile, "80082088_GS1DM.pdf");
	char szOutPDFFile1[MAX_PATH];
	GetModulePath(szOutPDFFile1, "_80082088_GS1DM_1.pdf");

	PDFForm_MergeFDFIntoPDF(szPDFFile, szFDFFile, szOutPDFFile1);

	char szOutPDFFile2[MAX_PATH];
	GetModulePath(szOutPDFFile2, "_80082088_GS1DM_2.pdf");

	string strFormValues;
	strFormValues += "GS1DM_322=>GS1DataMatrix=>(01)03400937777179(17)140630(10)BXA54G7";
	strFormValues += "\n";
	strFormValues += "DM_322=>Datamatrix=>01034009377771791714063010BXA54G7";
	strFormValues += "\n";
	strFormValues += "EAN128_325=>Code128_UCC=>(91)82367773(96)BXA54G7";
	int bRet = PDFForm_InsertBarcodeIntoPDF2(szOutPDFFile1, szOutPDFFile2, strFormValues.c_str());
	printf("Return value is: %d\n", bRet);
}

void TestFormFiller4()
{
	char szBarcodeTemp[MAX_PATH];
	GetModulePath(szBarcodeTemp, "example-mockup.pdf");
	char szBarcodeNew[MAX_PATH];
	GetModulePath(szBarcodeNew, "_mockup.pdf");

	PDFForm_SetLicenseKey("XXXXXXXXXXXXXXXXXXXXX");
	
	string strFormValues;
	strFormValues += "EAN128_610=>Code128=>1234567890";
	int bRet = PDFForm_InsertBarcodeIntoPDF2(szBarcodeTemp, szBarcodeNew, strFormValues.c_str());
	
	printf("Return value is: %d\n", bRet);
}

void TestFormFiller5()
{
	char szBarcodeTemp[MAX_PATH];
	GetModulePath(szBarcodeTemp, "example-mockup.pdf");
	char szBarcodeNew[MAX_PATH];
	GetModulePath(szBarcodeNew, "_mockup2.pdf");
	
	PDFForm_SetLicenseKey("XXXXXXXXXXXXXXXXXXXXX");
	
	string strFormValues;
	strFormValues += "EAN128_610=>BayerEAN128=>1234567890";
	int bRet = PDFForm_InsertBarcodeIntoPDF2(szBarcodeTemp, szBarcodeNew, strFormValues.c_str());
	
	printf("Return value is: %d\n", bRet);
}

void main(int argc, char *argv[])
{
	PDFForm_SetLicenseKey("XXXXXXXXXXXXXXXX");

	TestFormFiller1();
	TestFormFiller2();
	TestFormFiller3();
	TestFormFiller4();
	TestFormFiller5();
	return;
}